#include "Logger.hpp"
#include <stdio.h>
#include <stdarg.h>

Logger::Logger(Level level, bool useStdout)
: level_(level), stdout_(useStdout)
{
}

void Logger::debug(const TCHAR* message, ...) const
{
	if (level_ >= Level::DEBUG)
	{
		va_list arguments;
		va_start(arguments, message);
		if (stdout_)
			_vftprintf(stdout, message, arguments);
		else
			_vftprintf(stderr, message, arguments);
		va_end(arguments);
	}
}

void Logger::verbos(const TCHAR* message, ...) const
{
	if (level_ >= Level::VERBOS)
	{
		va_list arguments;
		va_start(arguments, message);
		if (stdout_)
			_vftprintf(stdout, message, arguments);
		else
			_vftprintf(stderr, message, arguments);
		va_end(arguments);
	}
}

void Logger::info(const TCHAR* message, ...) const
{
	if (level_ >= Level::NORMAL)
	{
		va_list arguments;
		va_start(arguments, message);
		if (stdout_)
			_vftprintf(stdout, message, arguments);
		else
			_vftprintf(stderr, message, arguments);
		va_end(arguments);
	}
}

void Logger::warn(const TCHAR* message, ...) const
{
	va_list arguments;
	va_start(arguments, message);
	_vftprintf(stderr, message, arguments);
	va_end(arguments);
}

void Logger::error(const TCHAR* message, ...) const
{
	va_list arguments;
	va_start(arguments, message);
	_vftprintf(stderr, message, arguments);
	va_end(arguments);
}
